
#include <allegro.h>
#include <iostream>
#include <vector>
#include <math.h>
#include <list>
#include <set>
#include <fstream>
#include <algorithm>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif
#include "random.hpp"
#include "map.txt"

using namespace std;
const float PI = 3.1415926535;
BITMAP* buffer;
BITMAP* sheet;
FONT* f;

int endtimer=0;

/*
 
map

 101
 101
 101
 111
 
 
 
 */

const bool mapmask[5][5]=
{
{1,0,1,0,1},
{1,0,1,0,1},
{1,0,1,0,1},
{1,0,0,0,1},
{1,1,1,1,1}
};


int brightness;
char itemcounttext[30];

const int TILE_WIDTH=11;
const int TILE_HEIGHT=14;

const int SCREEN_WIDTH=800;
const int SCREEN_HEIGHT=600;

const int endx=55; const int endy=8;


int magenta;
int red;
int lightred;
int black;
int white;
int green;
int lightgreen;
int orange;
int purp0;
int purp1;
int purp2;
int grey;
int lightgrey;
int blue;
int yellow;
int bgcol;

void cutbars()
{
	rectfill(buffer, 0, 0, SCREEN_WIDTH, 200, black);
	rectfill(buffer, 0, SCREEN_HEIGHT-200, SCREEN_WIDTH, SCREEN_HEIGHT, black);
}

int itemcount=0;


bool spacepressed;


bool quit=false;


int algdone=false;

char leveltitle[200];



int levelseed;
const int TILE_SIZE=13;
const int MARGIN=10;
const int TRIANGLE_SIZE = 50;
const int ICON_RADIUS = 10;
const int FRAMERATE=60;
const int FONT_HEIGHT=8;
int bltime;
int endmenutimer;
bool endmode;

bool gameover;

bool dragmode;
uint curnote;

uint melody_length=10;
int level_code;

struct Pos{
	float x;
	float y;
	float a;
};
Pos pos;

const Pos lights[2] = 
{
{1.5,-1,0},
{3.5,-1,0}
};

bool deadly[46][61];

Pos target[2];
bool inbase[2];

Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies

#include "sound.hpp"
#include "timer.hpp"

const int ts=13;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

int leveltimer;

int levelgoal;



bool stoppedfather;
bool upblock;



const int T1=35;
const int T2=25;

int killtimer=0;
int  jumptimer=0;
int frame;
bool dir;
class LevelLoop
{
	public:
	static void initialize()
	{
		itemcount=0;
		escpressed=true;
		quit=false;
		jumptimer=0;
		dir=0;
		frame=0;
		killtimer=0;
		finishedtitle=false;
		pos.x=1.5;
		pos.y=1.5;
		pos.a=3*PI/2;
		jumptimer=0;
		dir=0;
		pos.y=0;
	}
	static bool quitcondition()
	{
		return quit||finishedtitle;
	}
	static void logic()
	{
		static int frametimer=0;
		frametimer=(frametimer+1)%10;
		
		if (!escpressed && key[KEY_ESC])
		{
			quit=true;
		}
		escpressed=key[KEY_ESC];
		
		bool moving=false;;
		if (key[KEY_LEFT])
		{	
			moving=true;
			pos.x--;
			dir=1;
			if (frametimer==0)
			{
				frame=1+((frame)%2);
			}
				
		}	
			
		if (key[KEY_RIGHT])
		{	
			moving=true;
			dir=0;
			pos.x++;
			if (frametimer==0)
			{
				frame=1+((frame)%2);
			}
		}	
		
		if (key[KEY_SPACE])
		{
			if (pos.y==0)
			{
				moving=true;
				frame=2;
				jumptimer=20;
				playsample(0);
			}
		}
		
		if (jumptimer>0)
		{
			frame=2;
			jumptimer--;
			if (jumptimer>3)
			{
				pos.y--;
			}
		}
		else 
		{
			if (pos.y<0)
			{
				
				frame=2;
				pos.y++;
			}
		}
		
		if (!moving)
			frame=0;
	}
	static void draw()
	{
		clear_to_color(buffer,makecol(254,239,214));
		rectfill(buffer, 0,SCREEN_HEIGHT/2+1,  SCREEN_WIDTH-1,SCREEN_HEIGHT-1, makecol(60,49,71));
		hline(buffer, 0, SCREEN_HEIGHT/2, SCREEN_WIDTH, makecol(60,255,71));
		masked_blit(sheet, buffer, frame*18, dir*26, SCREEN_WIDTH/2-9, SCREEN_HEIGHT/2-25+pos.y, 18, 26);
	}
};

template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}


			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();



int storyprogress;
bool finishedstory;
int pauseafter;



class IntroLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);

		}
	};


class IntroDialogue
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			quit=false;
		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}
		
		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);
			
		}
	};


class GameOverLoop
	{
	public:
		static void initialize()
		{

			spacepressed=true;
			quit=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{


			if ((key[KEY_ESC]&&!escpressed)||key[KEY_SPACE])
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "and you won", 160, 4*10,white, -1);
			textout_centre_ex(buffer, f, "and nothing will be the same again", 160, 5*10,white, -1);
		}
	};


class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			levelseed=1;
			spacepressed=true;
			endmode=false;
			endmenutimer=0;
			quit=false;
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;


				return;
			}

			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					upheld=true;
					playsample(1);
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					downheld=true;
					playsample(1);
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(1);
					}
					else
					{
						quit=true;
						endmenutimer=40;
						playsample(1);
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,bgcol);

			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			textout_right_ex(buffer,f,"adventure game",700,40,makecol(255,255,255),-1);

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,f," START ",20+60+50,420,bgcol,makecol(255,255,255));
				textout_ex(buffer,f," Exit ",20+60+50,440,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,f," Start ",20+60+50,420,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,f," EXIT ",20+60+50,440,bgcol,makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;





template<class T>
void loop()
{

	clear_to_color(buffer, bgcol);

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        blit(buffer, screen, 0, 0, 0,0,SCREEN_WIDTH, SCREEN_HEIGHT);

	}
}



void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0) ;

	red=makecol(255,0,0);
	lightred=makecol(255,200,200);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(0,0,255);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);
	lightgreen=makecol(200,255,200);
	grey=makecol(100,100,100);
	lightgrey=makecol(200,200,200);
	orange=makecol(253,183,58);
	purp0=makecol(107,30,98);
	purp1=makecol(199,40,162);
	purp2=makecol(255,220,255);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	sheet=load_bitmap("bmp/frame.bmp",NULL);
	f=load_bitmap_font("bmp/font.pcx",NULL,NULL);
	if (f==0)
	{
		exit(0);
	}
	
}

int px;
int py;

bool gototitle=false;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:
	gototitle=false;

	loop<TitleLoop>();

	if (quit)
		goto end;

	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}
	
	loop<BlackLoop<2> >();
	
	playmusic(0);
	loop<LevelLoop >();
	stopmusic();
menuskip:
	quit=false;
	finishedtitle=false;
	TitleLoop::begin=false;
	goto titletag;

end:
	quit=false;
	return 0;

}
END_OF_MAIN()
